<?php

namespace TC\PayPalTax;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
	{
		$entity = \XF::em()->create('XF:PaymentProvider');
		$entity->bulkSet([
			'provider_id'    => "paypalt",
			'provider_class' => "TC\\PayPalTax:PayPalTax",
			'addon_id'       => "TC/PayPalTax"
		]);
		$entity->save();
	}

	public function upgrade(array $stepParams = [])
	{
		$this->uninstall();
		$this->install();
	}

	public function uninstallStep1()
	{
		$entity = \XF::em()->find('XF:PaymentProvider', 'paypalt');
		if($entity)
		{
			$entity->delete();
		}
	}
}