<?php

namespace TC\PaygateWebMoney;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
	{
		$db = $this->db();

		$db->insert('xf_payment_provider', [
			'provider_id'    => "tcWebmoney",
			'provider_class' => "TC\\PaygateWebMoney:WebMoney",
			'addon_id'       => "TC/PaygateWebMoney"
		]);
	}

	public function upgrade1020071Step1()
	{
		$db = $this->db();

		$db->delete('xf_payment_provider', "provider_id = 'webmoney'");

		$db->insert('xf_payment_provider', [
			'provider_id'    => "tcWebmoney",
			'provider_class' => "TC\\PaygateWebMoney:WebMoney",
			'addon_id'       => "TC/PaygateWebMoney"
		]);
	}

	public function upgrade1020072Step1()
	{
		$db = $this->db();

		$db->update('xf_payment_profile', ['provider_id' => 'tcWebmoney'], 'provider_id = ?', 'webmoney');
	}

	public function uninstallStep1()
	{
		$db = $this->db();

		$db->delete('xf_payment_profile', "provider_id = 'tcWebmoney'");
		$db->delete('xf_payment_provider', "provider_id = 'tcWebmoney'");
	}
}