<?php

namespace TC\PaygateYandexMoney;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
	{
		$db = $this->db();

		$db->insert('xf_payment_provider', [
			'provider_id'    => "tcYandexM",
			'provider_class' => "TC\\PaygateYandexMoney:YandexMoney",
			'addon_id'       => "TC/PaygateYandexMoney"
		]);
	}

	public function upgrade1020070Step1()
	{
		$db = $this->db();

		$db->delete('xf_payment_provider', "provider_id = 'yandexm'");

		$db->insert('xf_payment_provider', [
			'provider_id'    => "tcYandexM",
			'provider_class' => "TC\\PaygateYandexMoney:YandexMoney",
			'addon_id'       => "TC/PaygateYandexMoney"
		]);
	}

	public function upgrade1020070Step2()
	{
		$db = $this->db();

		$db->update('xf_payment_profile', ['provider_id' => 'tcYandexM'], 'provider_id = ?', 'yandexm');
	}

	public function upgrade1020172Step1()
	{
		$db = $this->db();

		$db->update('xf_payment_provider', ['provider_id' => 'tcYandexM'], 'provider_id = ?', 'yandexm');
		$db->update('xf_payment_provider', ['addon_id' => 'TC/PaygateYandexMoney'], 'addon_id = ?', 'TC/YandexMoney');
	}

	public function uninstallStep1()
	{
		$db = $this->db();

		$db->delete('xf_payment_profile', "provider_id = 'tcYandexM'");
		$db->delete('xf_payment_provider', "provider_id = 'tcYandexM'");
	}
}