<?php

namespace TC\RequireUserField;

use XF;
use XF\Entity\User;
use XF\Mvc\Controller;
use XF\Mvc\ParameterBag;

class Listener
{
	public static function preDispatchController(Controller $controller, $action, ParameterBag $params): void
	{
		if ($controller instanceof XF\Pub\Controller\AbstractController && !($controller instanceof XF\Pub\Controller\Account))
		{
			self::assertRequiredUserFields($controller, $action);
		}
	}

	public static function assertRequiredUserFields(Controller $controller, $action): void
	{
		/** @var User $visitor */
		$visitor = XF::visitor();

		$requiredFields = XF::options()->tcRUF_requiredFields;

		if ($visitor->user_id)
		{
			$required = [];
			foreach ($requiredFields as $requiredField)
			{
				if (empty($visitor->Profile->custom_fields->{$requiredField}))
				{
					$required[] = $requiredField;
				}
			}

			if (!empty($required))
			{
				$viewParams = [
					'requiredFields' => $required
				];

				$view = $controller->view('XF:Login\PasswordConfirm', 'tc_ruf_user_fields', $viewParams);

				throw $controller->exception($view);
			}
		}
	}
}
