<?php

namespace TC\RequireUserField\XF\Pub\Controller;

class Account extends XFCP_Account
{
	public function actionSaveRequired()
	{
		$this->assertPostOnly();

		$this->requiredFieldsSaveProcess(\XF::visitor())->run();

		return $this->redirect($this->getDynamicRedirect($this->buildLink('account/account-details')));
	}

	protected function requiredFieldsSaveProcess(\XF\Entity\User $visitor)
	{
		$form = $this->formAction();

		$this->customFieldsSaveProcess($form, 'personal', $visitor->Profile, true);
		$this->customFieldsSaveProcess($form, 'contact', $visitor->Profile, true);
		$this->customFieldsSaveProcess($form, 'preferences', $visitor->Profile, true);

		$form->complete(function() use ($visitor)
		{
			/** @var \XF\Repository\IP $ipRepo */
			$ipRepo = $this->repository('XF:Ip');
			$ipRepo->logIp($visitor->user_id, $this->request->getIp(), 'user', $visitor->user_id, 'preferences_edit');
		});

		return $form;
	}
}
